function [data] = getISspicedata(filename)
startstr = ' *******************************************************************************';
endstr = '************ Parts Statistics ************';

output_number = 0;
col_names = ['TIME'];

fid = fopen(filename);
tline = fgetl(fid);
while ischar(tline)
    output_number=output_number+1;
    while ischar(tline)
        tline = fgetl(fid);
        if strcmp(startstr, tline)
            break
        end
    end

    fgetl(fid); % blank
    new_col_names = textscan(fid,'%s %s %s',1);
    col_names = [col_names,new_col_names{2}];
    fgetl(fid); % blank
    fgetl(fid); % blank

    new_data = textscan(fid, '%f %f %f');
    if ~exist('data')
        data{1}=new_data{1}; % Time
    end
        data{output_number + 1}=new_data{2}; % output
    
    tline=fgetl(fid); % blank
    if strcmp(endstr, tline)
        break
    end
end

fclose(fid);

data = cell2struct(data,col_names, 2);
