function [ Out ] = psoParser( particles, accel, tests, generations )
%PSOPARSER Reads a set of csvs, averages and plots
%   Detailed explanation goes here
x = particles:particles:(particles*generations);
allTests = zeros(150,tests);
for i=1:tests
    filename = sprintf('p%d_a%d_test_%d.csv',particles,accel,i);
    allTests(:,i) = csvread(filename)';
end
averageTest = mean(allTests,2);
plot(x,averageTest','LineWidth',2);
Out = [averageTest';x];
end