function [data] = spice_ha(W)
% W: a vector of transtistor widths, length 15
% V_DD=

cir_lines = {'Half Adder';...
'*#save @M4[id] @M4[ig] @M4[iss] @M4[ib] @M4[p] @Vdd[i] @Vdd[p] @CL[i]';...
'*#save @CL[p] V(2) @R1[i] @R1[p] V(dd) V(1) @M2[id] @M2[ig]';...
'*#save @M2[iss] @M2[ib] @M2[p] @M3[id] @M3[ig] @M3[iss] @M3[ib] @M3[p]';...
'*#save @M1[id] @M1[ig] @M1[iss] @M1[ib] @M1[p] V(6) V(cp) V(3)';...
'*#save V(a) V(b) @M5[id] @M5[ig] @M5[iss] @M5[ib] @M5[p] V(7)';...
'*#save @CLs[i] @CLs[p] V(9) @R2[i] @R2[p] @M6[id] @M6[ig] @M6[iss]';...
'*#save @M6[ib] @M6[p] @M7[id] @M7[ig] @M7[iss] @M7[ib] @M7[p] @M8[id]';...
'*#save @M8[ig] @M8[iss] @M8[ib] @M8[p] V(8) @M9[id] @M9[ig] @M9[iss]';...
'*#save @M9[ib] @M9[p] @M10[id] @M10[ig] @M10[iss] @M10[ib] @M10[p] V(12)';...
'*#save @M11[id] @M11[ig] @M11[iss] @M11[ib] @M11[p] @M12[id] @M12[ig] @M12[iss]';...
'*#save @M12[ib] @M12[p] @M13[id] @M13[ig] @M13[iss] @M13[ib] @M13[p] @M14[id]';...
'*#save @M14[ig] @M14[iss] @M14[ib] @M14[p] @Va[i] @Va[p] @Vb[i] @Vb[p]';...
'*#alias vc  v(1)';...
'*#alias vs  v(9)';...
'*#alias va  v(a)';...
'*#alias vb  v(b)';...
'.TRAN 0.1n 22n 0';...
'*#op';...
'*#show all : all';...
'*#showmod all : all';...
'.OPTIONS gmin=1n';...
'.OPTIONS acct';...
'.PRINT  TRAN Vc';...
'.PRINT  TRAN Vs';...
'.PRINT  TRAN Va';...
'.PRINT  TRAN Vb';...
sprintf('M2 6 cp 3 0 CMOSN L=1.2u W=%iu',W(2));...
'.MODEL CMOSN NMOS Level=3 CGBO=3.6144E-10 CGDO=4.0241E-10';...
'+ CGSO=4.0241E-10 CJ=3.8541E-04 CJSW=1.3940E-10';...
'+ DELTA=6.9670E-01 ETA=4.3680E-02 GAMMA=0.5863';...
'+ KAPPA=1.3960E-01 KP=9.6379E-05 LD=1.6470E-07 MJ=1.1854';...
'+ MJSW=0.125195 NFS=1.98E+12 NSUB=2.7470E+16 PB=0.800000';...
'+ PHI=0.600000 RSH=8.5450E+01 THETA=8.1220E-02 TOX=2.1200E-08';...
'+ TPG=1 UO=591.7 VMAX=1.7330E+05 VTO=0.7860 XJ=0.200000U';...
sprintf('M4 3 a 0 0 CMOSN L=1.2u W=%iu',W(4));...
'Vdd dd 0 DC=10';...
sprintf('M11 cp a 12 0 CMOSN L=1.2u W=%iu', W(11));...
'CL 1 0 0.01p';...
sprintf('M3 1 cp dd dd CMOSP L=1.2u W=%iu ',W(3));...
'.MODEL CMOSP PMOS Level=3 CGBO=3.3650E-10 CGDO=5.3752E-11';...
'+ CGSO=5.3752E-11 CJ=4.8447E-04 CJSW=1.6457E-10';...
'+ DELTA=1.5200E+00 ETA=1.6410E-01 GAMMA=0.4863';...
'+ KAPPA=9.6940E+00 KP=2.9352E-05 LD=2.2000E-08 MJ=0.5027';...
'+ MJSW=0.217168 NFS=3.46E+12 NSUB=1.8900E+16 PB=0.850000';...
'+ PHI=0.600000 RSH=1.0470E+02 THETA=1.2480E-01 TOX=2.1200E-08';...
'+ TPG=-1 UO=180.2 VMAX=3.7320E+05 VTO=-0.9056 XJ=0.200000U';...
sprintf('M1 1 cp 0 0 CMOSN L=1.2u W=%iu ',W(1));...
sprintf('M5 3 b 0 0 CMOSN L=1.2u W=%iu ',W(5));...
'CLs 9 0 0.01p';...
sprintf('M6 9 6 dd dd CMOSP L=1.2u W=%iu ',W(6));...
sprintf('M7 9 6 0 0 CMOSN L=1.2u W=%iu ',W(7));...
sprintf('M8 6 cp dd dd CMOSP L=1.2u W=%iu ',W(8));...
sprintf('M9 6 a 8 dd CMOSP L=1.2u W=%iu ',W(9));...
sprintf('M10 8 b dd dd CMOSP L=1.2u W=%iu ',W(10));...
sprintf('M12 12 b 0 0 CMOSN L=1.2u W=%iu ',W(12));...
sprintf('M13 cp a dd dd CMOSP L=1.2u W=%iu ',W(13));...
sprintf('M14 cp b dd dd CMOSP L=1.2u W=%iu ',W(14));...
'Va a 0 DC=10 PULSE 0 10 5n 0p 0p 10n 20n ';...
'Vb b 0 DC=10 PULSE 0 10 10n 0p 0p 10n 20n ';...
'.END '    
};

data = isspice(cir_lines);