limits = [1.2, 1000,Inf]; %Solution Min,Max, MaxVelocity
max_delay_allowed = 0.1*10^-9;
Eval_inv = get_eval_inv(limits,max_delay_allowed);

bestScore = Inf;
bestPos = [nan, nan];

tic
for Wn =      9.41:0.00001: 9.42
    for Wp =  15.45:0.00001: 15.46
        
        score = Eval_inv([Wn,Wp]); %Fitness is -1*Sum(Delays)
        if (score<bestScore)
           bestScore = score
           bestPos = [Wn,Wp]
        end
    end
   
end
fprintf('-------------\n BestScore: %d\n Wn = %d\n Wp= %d\n', bestScore, bestPos(1), bestPos(2))
toc