tests = 5;

limits = [1.2, 1000,Inf]; %Solution Min,Max, MaxVelocity
max_delay_allowed = 2*10^-9;

fid = fopen('resultsPSO_rc.txt','w');
accel = 2;
inertia = 0.9;
particles= 40;
generations = 300;
for i = 5:tests
    %clearvars -except tests limits max_delay_allowed fid accel inertia particles  j i 
        %%Matlab is crashing, klets make sure there is no issue
        %%with memory leaks
    fprintf('p_rc_test_%d.csv',i);
    fprintf(fid, '\nParams:\nvMax: Inf\nAccel: %f\nInertia: %f\nParticles: %d\n',accel,inertia,particles);
    fprintf('\nParams:\nvMax: Inf\nAccel: %f\nInertia: %f\nParticles: %d\n',accel,inertia,particles);
    [Solution, Fitness, gbest_history] = PSO(particles,...
                                             112,... %Dimentions
                                             limits,...
                                             generations, ... %generations
                                             get_lt_eval_rc(limits,max_delay_allowed),...
                                             false,...
                                             [inertia,accel]);
    fprintf(fid,'Area Test %d: %e\n',i,Fitness);
    filename = sprintf('p_rc_test_%d.csv',i);
    dlmwrite(filename,gbest_history(end,:));
end





fclose all;