function [data] = isspice(cir_lines)
    %Will throw exception if doesn't converge and so produced no output

    % Save file .cir line-by-line
    fp = fopen('temp.cir', 'w+');
    for ii = 1 : length(cir_lines)
     fprintf(fp, '%s\n', cir_lines{ii});
    end

    fclose(fp); 
    
    call_spice();

    % Read data saved in .csv files
    % (assuming name termination _ac_out.csv and _tran_out.csv)
    data = getISspicedata('temp.out');
    
    
    function []= call_spice()
        % ! "C:\spice8\is\spice4.exe" -noGraphics temp.cir 
        system('"C:\spice8\is\spice4.exe"  -runspice -automode -noGraphics temp.cir');
        
