tests = 1;

limits = [1.2, 1000,Inf]; %Solution Min,Max, MaxVelocity
max_delay_allowed = 0.1*10^-9;



accel = 2;
inertia = 0.9;
particles = 20;
generations = 300;
for i = 1:tests
    fprintf('\nParams:\nvMax: Inf\nAccel: %f\nInertia: %f\nParticles: %d\n',accel,inertia,particles);
    [Solution, Fitness, gbest_history] = PSO(particles,...
                                             2,...
                                             limits,...
                                             generations,...
                                             get_eval_inv(limits,max_delay_allowed),...
                                             true,...
                                             [inertia,accel]);
        fprintf('Area Test %d: %e\n',i,Fitness);
        filename = sprintf('p_inv__with_params_test_%d.csv',i);
        dlmwrite(filename,gbest_history);
end


fclose all;